#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "glut.h"
#include <math.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <malloc.h>
#include "resource.h"
#include "winappstdio.h"

#include "main.h"
#include "modelo.h"
#include "control.h"
#include "robot_control.h"
#include "serialterm.h"

#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glaux.lib")

#define	X_I 16
#define	Y_I 16


int ciclos=0;
char *IP;
//control_robot *pta3;

float VR=0.0;
float VL=0.0;
float V=0.0;
float W=0.0;

int initW=0;

bool continuar=true;
float L=0.41; 
float VMAX=1.2;


// posicion y configuracion de panrtalla

float PPX=0.0;
float PPY=0.0;
bool tipo_panel=true;

// guardar archivos

char *archivo;
FILE *datos_trayectoria;
bool guardar=false;

//clases robot control
class ArPose;
class ArTime;
class ArRobot;
class ArTcpConnection;
class ArAnalogGyro;
class ConnHandler;
class param_robot;
class robot_control;

// clases control

class graficos;
// variables de robot para interfaz de pantalla
class var_robot;
class sub_grilla;
class grilla;
class matriz_grilla;

DWORD iID[8];
DWORD WINAPI MyThread(LPVOID);
DWORD WINAPI modo_laser(LPVOID);
DWORD WINAPI modo_manual(LPVOID);
DWORD WINAPI plot_grilla(LPVOID);
DWORD WINAPI modo_manual_serial(LPVOID);
DWORD WINAPI modo_autom_serial(LPVOID);
DWORD WINAPI modo_gps(LPVOID);
DWORD WINAPI guardar_datos(LPVOID n);
DWORD WINAPI mostrar_datos(LPVOID n);

HANDLE hThreads[8];
DWORD waiter;

void display_grilla(void);
void SetupTexture(void);
void reshape(int, int);
void plot_grilla(float,float);

GLuint texture1,texture2;




//nave avion;
tm *tiempo;
// Vars de creacion de ventana / teclas
HDC			hDC=NULL;		
HGLRC		hRC=NULL;		
HWND		hWnd=NULL;		
HINSTANCE	hInstance;
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	traslacion(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    modopartida(HWND,UINT, WPARAM, LPARAM);
LRESULT CALLBACK    partida_serial(HWND,UINT,WPARAM,LPARAM);	
LRESULT CALLBACK    partida_serial_gps(HWND,UINT,WPARAM,LPARAM);	

GLuint	texture[5];		    // Storage For Textures
GLuint	monos;		     	// Storage For Textures
robot_control *controler;   // controlador del robot
graficos *plots; 
var_robot *variables;
char *puerto="COM2"; //puerto del GPS
char *tit_pantalla ="Controlador PTA3";
char *tit_panel ="Controlador PTA3 ( Modo Panel )";
char *tit_mapa ="Controlador PTA3 ( Modo Mapa )";
char *tit_cinematica ="Controlador PTA3 ( Modo Cinematico )";

bool habilitar_panel=true;
bool habilitar_letras=true;
bool configurar_OPEN_GL=true;
bool estado_control=false;

bool ver_panel=true;
bool ver_mapa=false;
bool ver_cinematica_vel=false;
bool ver_cinematica_acel=false;
int base;			        // Display list fonts

bool	keys[256];			
bool	active=TRUE;		
bool	fullscreen=TRUE;	
bool	tp;
bool	Texto;
int	    init_gl=1;


double eyex,eyey,eyez;
double centerx,centery,centerz;
double upx,upy,upz;
double eyed, phi,theta;
double dt;

double dx=2.0;
double dy=2.0;
double dz=2.0;

double col_R=0.6;
double col_G=0.0;
double col_B=0.0;
double col_T=0.0;

bool mouse=false;

bool borrar=false;

bool ayuda=false;



bool qp,wp,ep,ap,sp,dp,mp,rp,fp,space_p,cp,vp,hp,gp,num4p,num5p,num6p,num1p,num2p,num3p,num0p;


GLubyte *image;
GLuint texName;


int iheight, iwidth;

DWORD WINAPI modo_gps(LPVOID){
   main_gps();
return 0;
}

DWORD WINAPI MyThread(LPVOID n){

/*char* name=(char*)n;
for (int i=0;i<100;i++)
printf("hola %s i=%d",name,i);
return 0;
*/


main_(IP,8101,variables);
//MessageBox(hDlg,IP,"CARGANDO DIRECCION", MB_ICONEXCLAMATION | MB_OK);
return 0;
}


DWORD WINAPI modo_laser(LPVOID n){
int k=0;

   for(k=1;k>0;k++){
   variables->enter_laser();
   variables->actualizar_grilla();
   Sleep(100);}

return 0;
}

DWORD WINAPI modo_manual(LPVOID n){
main_manual(IP,8101,&VR,&VL,&continuar,variables);
return 0;
}

DWORD WINAPI modo_manual_serial(LPVOID n){
main_manual_serial(variables->puerto,&VR,&VL,&continuar,variables);
return 0;
}

DWORD WINAPI modo_autom_serial(LPVOID n){
main_serial(variables->puerto,variables);
return 0;
}

DWORD WINAPI guardar_datos(LPVOID n){

datos_trayectoria= fopen(archivo,"w");
if(datos_trayectoria!=NULL)
guardar=true;

while(guardar){
//tiempo pos_X pos_Y angulo_rot vel vel_rot acel acel_rot
	fprintf(datos_trayectoria,"%f %f %f %f %f %f %f %f %f %f\n",variables->tiempo,variables->pos_X,variables->pos_Y,variables->angulo_rot,variables->desp_X,variables->desp_Y,variables->velocidad,variables->vel_angulo_rot,variables->aceleracion,variables->acel_angulo_rot);
Sleep(100);
variables->tiempo=variables->tiempo+0.1;
}
if(datos_trayectoria!=NULL)
fclose(datos_trayectoria);	

return 0;
}

DWORD WINAPI mostrar_datos(LPVOID n){
   
   while(true){
      Sleep(100);
      variables->actualizar_datos();
   }
return 0;
}

void SetupTexture(void)
{   
	   
	const int texturesize1=128;
    const int texturesize2=128;

    GLubyte bits[texturesize1][texturesize1][4];
    for(int i=0;i<texturesize1;i++)
    {
    	for(int j = 0; j < texturesize1; j++)
        {
            //bits[i][j][0]= (GLbyte)random(0,255);
            //bits[i][j][1]= (GLbyte)random(0,255);
            //bits[i][j][2]= (GLbyte)random(0,255);
            
			if(variables->grilla_rec[j+variables->j_actual-64][i+variables->k_actual-64]){
            bits[i][j][0]= (GLbyte)0;
            bits[i][j][1]= (GLbyte)255;
            bits[i][j][2]= (GLbyte)0;
            }
			else if(variables->grilla_obs[j+variables->j_actual-64][i+variables->k_actual-64]){
            bits[i][j][0]= (GLbyte)255;
            bits[i][j][1]= (GLbyte)153;
            bits[i][j][2]= (GLbyte)0;
			}
            else{
			bits[i][j][0]= (GLbyte)0;
            bits[i][j][1]= (GLbyte)0;
            bits[i][j][2]= (GLbyte)0;
            }
			
			bits[i][j][3]= (GLbyte)255;
        }
    }

    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);   // specify memory alignment
    glGenTextures(1, &texture1);
    glBindTexture(GL_TEXTURE_2D, texture1);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texturesize1, texturesize1, 0, GL_RGBA, GL_UNSIGNED_BYTE, bits);


    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

}


void plot_grilla(float posX,float posY){
    

	glPushMatrix();
	
	   
	glColor3f(19.0/256,46.0/256,144.0/256);
	glLineWidth(2.0);
	
	glBegin( GL_LINES );
	glVertex2f(-2.6+posX,2.6+posY);
    glVertex2f(-2.6+posX,-2.6+posY);
    glEnd();

	glBegin( GL_LINES );
	glVertex2f(2.6+posX,-2.6+posY);
    glVertex2f(2.6+posX,2.6+posY);
    glEnd();

	glBegin( GL_LINES );
	glVertex2f(-2.6+posX,2.6+posY);
    glVertex2f(2.6+posX,2.6+posY);
    glEnd();

	glBegin( GL_LINES );
	glVertex2f(-2.6+posX,-2.6+posY);
    glVertex2f(2.6+posX,-2.6+posY);
    glEnd();

    glPopMatrix();

	glPushMatrix();
    SetupTexture();
    glBindTexture(GL_TEXTURE_2D, texture1);


    glBegin(GL_QUADS);                           // draw square
    glTexCoord2f(0.0,1.0);
    glVertex2f(-2.6+posX,2.6+posY);
    glTexCoord2f(0.0,0.0);
    glVertex2f(-2.6+posX,-2.6+posY);
    glTexCoord2f(1.0,0.0);
    glVertex2f(2.6+posX,-2.6+posY);
    glTexCoord2f(1.0,1.0);
    glVertex2f(2.6+posX,2.6+posY);
    glEnd();

    glPopMatrix();


};

void display_grilla(void){ 
int i;


for(int k=1;k>0;k++){

SetupTexture();
Sleep(100);

glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
glMatrixMode( GL_MODELVIEW_MATRIX );
//plot_GPS(0,0,1);

glBindTexture(GL_TEXTURE_2D, texture1);
glLoadIdentity();
//glTranslatef(0.0,00.00.0);
   glBegin(GL_QUADS);                           // draw square
   glTexCoord2f(0.0,0.0);
   glVertex2f(-0.5f,0.5f);
   glTexCoord2f(1.0,0.0);
   glVertex2f(-0.5f,-0.5f);
   glTexCoord2f(1.0,1.0);
   glVertex2f(0.5f,-0.5f);
   glTexCoord2f(0.0,1.0);
   glVertex2f(0.5f,0.5f);
   glEnd();

glColor3f(1.0, 1.0, 1.0);
drawString("hola",18,1,1,1,0,0.75);  

glFlush();

}

} 




/*  Create a 16x16x16x3 array with different color values in
 *  each array element [r, g, b].  Values range from 0 to 255.
 */
/*
void makeImage(void)
{
   int  t, r;
    
      for (t = 0; t < 15; t++)
         for (r = 0; r < 15; r++) {
            image[r][t][0] = (GLubyte) (r * 17);
            image[r][t][1] = (GLubyte) (t * 17);
			image[r][t][2] = (GLubyte) (t * 17);
         }
}
*/
/*funciones de probabilidades*/



void iniciarrand(){
time_t tiempo;
time(&tiempo);
srand(tiempo);}

int RANDOM(int a, int b){
double num;
num=(a + (((double)rand()/(double)RAND_MAX) * (double)(b-a)));
if( num - (int)num > 0.5) return((int)num+1);
else return((int)num);
}

int random(int a,int b){
int k;
k=RANDOM(a,b);
k=RANDOM(a,b);
return k;
}

int entrada(double prob){/*probabilidad de entrada*/
if(prob*100>random(0,100)) return 1;/*si*/
else return 0;
}


AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}



int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage=NULL;					// Create Storage Space For The Texture

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if ( TextureImage=LoadBMP("font.bmp") )
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(5, &texture[0]);					// Create Three Textures
			
		// Create Linear Filtered Texture for Font
			glBindTexture(GL_TEXTURE_2D, texture[4]);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage->sizeX, TextureImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);

		// Delete Temporary Texture Resource
		if (TextureImage)						// If Texture Exists
		{
			if (TextureImage->data)			// If Texture Image Exists
			{
				free(TextureImage->data);		// Free The Texture Image Memory
			}
			free(TextureImage);				// Free The Image Structure
		}
	}
	if ( TextureImage=LoadBMP("mono.bmp") )
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(4, &texture[0]);					// Create Three Textures
			
		// Create Linear Filtered Texture for Font
			glBindTexture(GL_TEXTURE_2D, texture[3]);
			
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
            glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE); 
            glEnable(GL_TEXTURE_2D);



			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage->sizeX, TextureImage->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);

		// Delete Temporary Texture Resource
		if (TextureImage)						// If Texture Exists
		{
			if (TextureImage->data)			// If Texture Image Exists
			{
				free(TextureImage->data);		// Free The Texture Image Memory
			}
			free(TextureImage);				// Free The Image Structure
		}
	}

	return Status;										// Return The Status
}

int LoadGLimagenes()									// Load Bitmaps And Convert To Textures
{
	int Status=TRUE;
/*   glClearColor (0.0, 0.0, 0.0, 0.0);
   glShadeModel(GL_FLAT);
   glEnable(GL_DEPTH_TEST);
	
   makeImage();
   glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

   glGenTextures(1, &texName);
   glBindTexture(GL_TEXTURE_2D, texName);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, 
                   GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, 
                   GL_NEAREST);
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 16, 16, 0, GL_RGB, GL_UNSIGNED_BYTE, image);
   glEnable(GL_TEXTURE_2D);
*/
	return Status;										// Return The Status
}

GLvoid imagenmono(GLvoid)								// Build Our Font Display List
{


	
/*	
	
	glBindTexture(GL_TEXTURE_2D,texture[3]);// Use A Quad For Each Character
	glColor3f(0.5,0.5,0.5);
	glBegin(GL_QUADS);	
				glTexCoord2f(0.0,0.0);			
				glVertex3f(10,10,10);					
				
				glTexCoord2f(1.0,0.0);			
				glVertex3f(10,10,-10);					

				glTexCoord2f(1.0,1.0);			
				glVertex3f(10,-10,-10);					
				
				glTexCoord2f(0.0,1.0);			
				glVertex3f(10,-10,10);					
				
				glEnd();									// Done Building Our Quad (Character)
*/

	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	
	glBindTexture(GL_TEXTURE_2D, texName);			// Select Our Font Texture
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,1024,0,768,-1,1);							// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix

	glEnable(GL_BLEND);
		// Select Our Font Texture

   // glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, 's');
   // glRasterPos2f(-0.1, 0.6);	

	
													// Loop Until All 256 Are Built




	glEnable(GL_DEPTH_TEST);

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix

	glDisable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);	




}


GLvoid BuildFont(GLvoid)								// Build Our Font Display List
{
	float	cx;											// Holds Our X Character Coord
	float	cy;											// Holds Our Y Character Coord

	base=glGenLists(256);								// Creating 256 Display Lists
	glBindTexture(GL_TEXTURE_2D, texture[4]);			// Select Our Font Texture
	for (int loop2=0; loop2<256; loop2++)				// Loop Through All 256 Lists
	{
		cx=float(loop2%16)/16.0f;						// X Position Of Current Character
		cy=float(loop2/16)/16.0f;						// Y Position Of Current Character

		glNewList(base+loop2,GL_COMPILE);				// Start Building A List
			glBegin(GL_QUADS);							// Use A Quad For Each Character
				glTexCoord2f(cx,1-cy-0.0625f);			// Texture Coord (Bottom Left)
				glVertex2i(0,0);						// Vertex Coord (Bottom Left)
				glTexCoord2f(cx+0.0625f,1-cy-0.0625f);	// Texture Coord (Bottom Right)
				glVertex2i(16,0);						// Vertex Coord (Bottom Right)
				glTexCoord2f(cx+0.0625f,1-cy);			// Texture Coord (Top Right)
				glVertex2i(16,16);						// Vertex Coord (Top Right)
				glTexCoord2f(cx,1-cy);					// Texture Coord (Top Left)
				glVertex2i(0,16);						// Vertex Coord (Top Left)
			glEnd();									// Done Building Our Quad (Character)
			glTranslated(13,0,0);						// Move To The Right Of The Character
		glEndList();									// Done Building The Display List
	}													// Loop Until All 256 Are Built
}

GLvoid KillFont(GLvoid)									// Delete The Font From Memory
{
	glDeleteLists(base,256);							// Delete All 256 Display Lists
}

GLvoid glPrint(GLint x, GLint y, int set, char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];					// Holds Our String
	va_list		ap;							// Pointer To List Of Arguments

	if (fmt == NULL)						// If There's No Text
		return;								// Do Nothing

	va_start(ap, fmt);						// Parses The String For Variables
	    vsprintf(text, fmt, ap);			// And Converts Symbols To Actual Numbers
	va_end(ap);								// Results Are Stored In Text

	if (set>1)								// Select Character Set
	{
		set=1;
	}

	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	
	glBindTexture(GL_TEXTURE_2D, texture[4]);			// Select Our Font Texture
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(-300,300,-225,255,0,0);	
	// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix

	glEnable(GL_BLEND);
	//color letra
	//glColor3f(1.0,1.0,1.0);
	glColor3f(255.0/256,153.0/256,0.0/256);
	glDisable(GL_DEPTH_TEST);	
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(text),GL_BYTE,text);				// Write The Text To The Screen
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix

	glDisable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);							
}


GLvoid glPrintf(GLint x, GLint y, int set, char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];					// Holds Our String
	va_list		ap;							// Pointer To List Of Arguments

	if (fmt == NULL)						// If There's No Text
		return;								// Do Nothing

	va_start(ap, fmt);						// Parses The String For Variables
	    vsprintf(text, fmt, ap);			// And Converts Symbols To Actual Numbers
	va_end(ap);								// Results Are Stored In Text

	if (set>1)								// Select Character Set
	{
		set=1;
	}

	glEnable(GL_TEXTURE_2D);
//	glDisable(GL_LIGHTING);
	
	glBindTexture(GL_TEXTURE_2D, texture[4]);			// Select Our Font Texture
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(-600,600,-450,450,0,1);							// Set Up An Ortho Screen
	//gluLookAt(0.0,0.0,16.0,0,0.0,0.0,0.0,1.0,0.0);
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix

	glEnable(GL_BLEND);
	//color letra
	//glColor3f(1.0,1.0,1.0);
	glColor3f(255.0/256,153.0/256,0.0/256);
	glDisable(GL_DEPTH_TEST);	
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(text),GL_BYTE,text);				// Write The Text To The Screen
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix

	glDisable(GL_TEXTURE_2D);
	//glEnable(GL_LIGHTING);							
}

void Mensajes(){
     //mensajes de la pantalla
     glPrint(5,500,0,"CICLOS %d",ciclos);
     glPrint(5,480,0,"P MUESTREO");
     glPrint(5,460,0,"(S) : %d",ciclos);
     glPrint(5,440,0,"F FIJADA");
     glPrint(5,420,0,"(Hz): %d",ciclos);
     glPrint(5,400,0,"A FIJADA");
     glPrint(5,380,0,"(V) : %d",ciclos);
     glPrint(5,360,0,"V MEDIDO");
     glPrint(5,340,0,"(V) : %d",ciclos);
	 
	 glPrint(5,560,0," %f , %f , %f ",eyex,eyez,eyey);
	 glPrint(5,540,0," %f , %f , %f ",centerx,centerz,centery);
	 glPrint(5,520,0," %f , %f , %f ",upx,upz,upy);

	 ciclos++;

 }

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		
{
	if (height==0)										
	{
		height=1;										
	}

//	glViewport(-width,-height,2*width,2*height);						
	glViewport(0,0,width,height);						

	glMatrixMode(GL_PROJECTION);						
	glLoadIdentity();									

	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							
	glLoadIdentity();									
}

int InitGL(GLvoid)										
{	
	phi   = M_PI/2.0;
	theta = M_PI/2.0;
	eyed  = 16.0;
	dt	  = 0.01;

	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

	BuildFont();										// Build the Font

	if (!LoadGLimagenes())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}
   
	//image = glmReadPPM("data/fishermen.ppm", &iwidth, &iheight);
	//imagenmono();
   
#ifdef CENTRO
	centerx = eyed*sin(phi)*cos(theta);
	centery = eyed*sin(phi)*sin(theta);
	centerz = eyed*cos(phi);
	eyex = eyey = eyez = 0.0;
#else
	eyex = eyed*sin(phi)*cos(theta);
	eyey = eyed*sin(phi)*sin(theta);
	eyez = eyed*cos(phi);
	centerx = centery = centerz = 0.0;
#endif

	upx = upy = 0.0;
	upz = 1.0;
	GLfloat specular[] = { 0.3f, 0.3f, 0.3f, 1.0f };
	GLfloat brillo[]={100.0};
	//Iluminacion
	GLfloat light_ambient[] = { 0.3f, 0.3f, 0.3f, 1.0f };
	GLfloat light_diffuse[] = { 1.0, 1.0, 1.0, 1.0 }; //Tonalidad de luz
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	/*	light_position is NOT default value	*/
	GLfloat light_position[] = { 2.0, 2.0, 3.0, 0.0 };
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,specular);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,brillo);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	glLightfv (GL_LIGHT0, GL_AMBIENT, light_ambient);
	//glLightfv (GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	//glLightfv (GL_LIGHT0, GL_SPECULAR, light_specular);
	glLightfv (GL_LIGHT0, GL_POSITION, light_position);
	
	glEnable (GL_LIGHTING);
	glEnable (GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);

	glEnable(GL_TEXTURE_2D);	
	glEnable(GL_COLOR_MATERIAL);
	glShadeModel(GL_SMOOTH);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);								
	glEnable(GL_DEPTH_TEST);							
	glColor4f(1.0f,1.0f,1.0f,0.5f);
	
	return TRUE;										
}

GLvoid KillGLWindow(GLvoid)								
{
	if (fullscreen)										
	{
		ChangeDisplaySettings(NULL,0);					
		ShowCursor(TRUE);								
	}

	if (hRC)											
	{
		if (!wglMakeCurrent(NULL,NULL))					
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","ERROR DE APAGADO",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						
		{
			MessageBox(NULL,"Release Rendering Context Failed.","ERROR DE APAGADO",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					
	{
		MessageBox(NULL,"Release Device Context Failed.","ERROR DE APAGADO",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										
	}

	if (hWnd && !DestroyWindow(hWnd))					
	{
		MessageBox(NULL,"Could Not Release hWnd.","ERROR DE APAGADO",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										
	}

	if (!UnregisterClass("OpenGL",hInstance))			
	{
		MessageBox(NULL,"No puede no registrar la clase.","ERROR DE APAGADO",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									
	}

	KillFont();
//    avion.destroy();
}
 

bool CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;
	
	WNDCLASSEX	wc;	
	wc.cbSize = sizeof(WNDCLASSEX);
	DWORD		dwExStyle;				
	DWORD		dwStyle;				
	RECT		WindowRect;				
	WindowRect.left=(long)0;			
	WindowRect.right=(long)width;		
	WindowRect.top=(long)0;				
	WindowRect.bottom=(long)height;		

	fullscreen=fullscreenflag;			

	hInstance			= GetModuleHandle(NULL);				
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC ;	
	wc.lpfnWndProc		= (WNDPROC) WndProc;					
	wc.cbClsExtra		= 0;									
	wc.cbWndExtra		= 0;									
	wc.hInstance		= hInstance;							
	wc.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_CACA2);			
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			
	wc.hbrBackground	= NULL;									
	wc.lpszMenuName		= (LPCSTR)IDC_CACA2;									
	wc.lpszClassName	= "OpenGL";	
	wc.hIconSm		    = LoadIcon(wc.hInstance, (LPCTSTR)IDI_SMALL);
    
	if (!RegisterClassEx(&wc))									
	{
		MessageBox(NULL,"Fallo al registrar la Windows Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											
	}

	if (fullscreen)												
	{
		dwExStyle=WS_EX_APPWINDOW;								
		dwStyle=WS_POPUP;										
		ShowCursor(FALSE);										
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			
		dwStyle=WS_OVERLAPPEDWINDOW;							
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		

	
	if (!(hWnd=CreateWindowEx(	dwExStyle,"OpenGL",	title,								
								dwStyle | WS_CLIPSIBLINGS |	WS_CLIPCHILDREN,					
								0, 0, WindowRect.right-WindowRect.left,	
								WindowRect.bottom-WindowRect.top,	
								NULL,NULL,hInstance,NULL)))								
	{
		KillGLWindow();								
		MessageBox(NULL,"Error en la creacion de la ventana.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	static	PIXELFORMATDESCRIPTOR pfd=				
	{	sizeof(PIXELFORMATDESCRIPTOR),1,											
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,							
		PFD_TYPE_RGBA, bits,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,PFD_MAIN_PLANE,								
		0,0,0,0	};
	
	if (!(hDC=GetDC(hWnd)))	{
		KillGLWindow();								
		MessageBox(NULL,"No puede crear un GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	{
		KillGLWindow();								
		MessageBox(NULL,"No puede encontrar un Formato de pixel Suitable.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd)){
		KillGLWindow();								
		MessageBox(NULL,"No se puede setear el Formato de Pixel.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if (!(hRC=wglCreateContext(hDC))){
		KillGLWindow();								
		MessageBox(NULL,"No se puede crear un GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if(!wglMakeCurrent(hDC,hRC)){
		KillGLWindow();								
		MessageBox(NULL,"No se puede activar el GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	ShowWindow(hWnd,SW_SHOW);						
	SetForegroundWindow(hWnd);						
	SetFocus(hWnd);									
	ReSizeGLScene(width, height);					

	if (!InitGL()){
		KillGLWindow();								
		MessageBox(NULL,"Fallo en la inicializacion.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	return TRUE;									
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT	uMsg,WPARAM	wParam,LPARAM	lParam)			
{int wmId, wmEvent;
	switch (uMsg)
		

	{	case WM_COMMAND:		// Parse the menu selections:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInstance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;

				case ID_ARCHIVO_INICIO_MODOSERIAL:
				   DialogBox(hInstance, (LPCTSTR)IDD_MODO_COM, hWnd, (DLGPROC)partida_serial);
				   break;

				case ID_ARCHIVO_INICIO_MODOIP_PTA31:
                   IP="192.168.1.99";
				   DialogBox(hInstance, (LPCTSTR)IDD_MODO_IP, hWnd, (DLGPROC)modopartida);
				   break;

				case ID_ARCHIVO_INICIO_MODOIP_PTA32:
				   IP="192.168.1.101";
				   DialogBox(hInstance, (LPCTSTR)IDD_MODO_IP, hWnd, (DLGPROC)modopartida);
				   break;

				case ID_ARCHIVO_INICIO_MODOIP_TEST:
				   variables->modo_comunicacion=1;
				   IP="127.0.0.1";
				   DialogBox(hInstance, (LPCTSTR)IDD_MODO_IP, hWnd, (DLGPROC)modopartida);
				   break;

				case ID_ARCHIVO_TRAYECTORIAS_GUARDAR:
                   archivo="trayectoria.txt";
				   hThreads[6] = CreateThread(NULL,0,guardar_datos,"T6",NULL,&iID[6]);
				   MessageBox(hWnd,archivo,"GRABANDO DATOS", MB_ICONEXCLAMATION | MB_OK);
				   break;

				case ID_ARCHIVO_TRAYECTORIAS_DETENER:
                   guardar=false;
				   MessageBox(hWnd,archivo,"DETENER GRABACION", MB_ICONEXCLAMATION | MB_OK);
				   break;

                /*case ID_CONFIGURACION_CONFIGURARPANEL:
                    tipo_panel=false; //visualizacion de letras   
					break;*/

				case ID_OCULTAR:
					if(habilitar_letras)
						habilitar_letras=false;
					else
						habilitar_letras=true;

					break;

                case ID_CONFIGURACION_CONFIGURARPANEL_CONFIGURAROPENGL:
					if(configurar_OPEN_GL)
						configurar_OPEN_GL=false;
					else
						configurar_OPEN_GL=true;					
					break;

                case ID_GRAFICOS_PANELDECONTROL:
					ver_panel=true;
					ver_mapa=false;
					ver_cinematica_vel=false;
					ver_cinematica_acel=false;
					tit_pantalla=tit_panel;
					break;

                case ID_GRAFICOS_PLANOXY:
					ver_panel=false;
					ver_mapa=true;
					ver_cinematica_vel=false;
					ver_cinematica_acel=false;
					tit_pantalla=tit_mapa;
					break;

				case ID_GRAFICOS_CINEMATICO_VELOCIDADES:
					ver_panel=false;
					ver_mapa=false;
					ver_cinematica_vel=true;
					ver_cinematica_acel=false;
					tit_pantalla=tit_cinematica;
					break;

				case ID_GRAFICOS_CINEMATICO_ACELERACIONES:
					ver_panel=false;
					ver_mapa=false;
					ver_cinematica_vel=false;
					ver_cinematica_acel=true;
					tit_pantalla=tit_cinematica;
					break;

                case ID_LASER_5M:					
					variables->radio_max=5.0;
					break;

                case ID_LASER_10M:					
					variables->radio_max=10.0;
					break;

                case ID_LASER_25M:					
					variables->radio_max=25.0;
					break;
				
				case ID_LASER_50M:					
					variables->radio_max=50.0;
					break;

                case ID_CONFIGURACION_HABILITARGPS:
					DialogBox(hInstance, (LPCTSTR)IDD_MODO_COM, hWnd, (DLGPROC)partida_serial_gps);
					break;

				case ID_CONFIGURACION_HABILITARLASER:

					if(variables->habilitar_laser)
						variables->habilitar_laser=false;
					else
						variables->habilitar_laser=true;

					break;
                				
				case ID_CONFIGURACION_CONTROLES:

                       if (habilitar_panel)
                       habilitar_panel=false;   
					   else
					   habilitar_panel=true;

				   break;  
                    
                case ID_TRASLACION:

				   DialogBox(hInstance, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)traslacion);
				   break;

                case ID_RESET:
                   
//				   avion.reset();
                   phi   = M_PI/2.0;
                   theta = M_PI/2.0;
	               eyed  = 16.0;
                   dt	  = 0.01;


				   MessageBox(NULL,"RESETEANDO PROGRAMA.","REINICIADO",MB_OK | MB_ICONINFORMATION);
				   break;
				   


				case IDM_EXIT:
				   PostQuitMessage(0);
				   delete controler;   
                   delete plots; 
                   delete variables;
    			   return 0;				
				   break;
				default:
				   return DefWindowProc(hWnd, uMsg, wParam, lParam);
			}
			break;

		case WM_ACTIVATE:							
		{
			if (!HIWORD(wParam))					
			{
				active=TRUE;						
			}
			else
			{
				active=FALSE;						
			}

			return 0;								
		}

		case WM_SYSCOMMAND:							
		{
			switch (wParam)							
			{
				case SC_SCREENSAVE:					
				case SC_MONITORPOWER:				
				return 0;							
			}
			break;									
		}

		case WM_CLOSE:								
		{   delete controler;   
            delete plots; 
            delete variables;

			PostQuitMessage(0);						
			return 0;								
		}

		case WM_KEYDOWN:							
		{
			keys[wParam] = TRUE;					
			return 0;								
		}

		case WM_KEYUP:								
		{
			keys[wParam] = FALSE;					
			return 0;								
		}

		case WM_SIZE:								
		{  
			//int iheight, iwidth;
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  
			return 0;								
		}

		case WM_LBUTTONDOWN:
		{
			mouse=true;
			ShowCursor(false);
			return 0;
		}

		case WM_LBUTTONUP:
		{
			mouse=false;
			ShowCursor(true);
			return 0;
		}
		break;
	}

	
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG		msg;									
	BOOL	done=FALSE;	
   
 
	fullscreen=FALSE;	

    iniciarrand();
	if (!CreateGLWindow(tit_pantalla,600,450,8,fullscreen))
	{
		return 0;									
	}
    else{
       //char *IP = "127.0.0.1";
     //init_angle(cos_angle,sin_angle,361);
								
	variables= new var_robot();
	plots=new graficos();
    OpenWinAppConsole("Estado de comunicaciones");  
	//variables->enter_laser();
	hThreads[2] = CreateThread(NULL,0,modo_laser,"T3",NULL,&iID[2]);
	hThreads[7] = CreateThread(NULL,0,mostrar_datos,"T7",NULL,&iID[7]);
	
	}

	while(!done)									
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	
		{
			if (msg.message==WM_QUIT)				
			{
				done=TRUE;							
			}
			else									
			{
				TranslateMessage(&msg);				
				DispatchMessage(&msg);				
			}
		}
		else										
		{
			
			if (active)								
			{   
				
			    if (keys[VK_ESCAPE])				
				{
					done=TRUE;						
				}
				else								
				{
                    
                    if (initW==0)
						W=0;
					else
					   initW=initW-1;
					
					
					if (init_gl==1){
                    init_gl=0;
					glViewport(0,0,600,450);						

                  	glMatrixMode(GL_PROJECTION);						
	                glLoadIdentity();									

                   	gluPerspective(45.0f,600.0/450.0,0.1f,100.0f);

                  	glMatrixMode(GL_MODELVIEW);							
					glLoadIdentity();
					}	

					DrawGLScene(plots->cos_aux,plots->sin_aux);
					SwapBuffers(hDC);
					waiter = WaitForMultipleObjects(4,hThreads,TRUE,INFINITE);

					
				

				//SETEADORES DE PLANOS
				//TECLAS DE ROTACION
					if (keys[VK_UP]){
						
						if (V<VMAX)
						V=V+0.01;
						else
						V=VMAX;
						
						VR=(V+W*L/2.0);
						VL=(V-W*L/2.0);

					}
					if (keys[VK_DOWN]){
						
						if (V>-VMAX)
						V=V-0.01;
						else
						V=-VMAX;

						VR=(V+W*L/2.0);
						VL=(V-W*L/2.0);

					}
					if (keys[VK_LEFT]){
						
						if (V>=0)
						W=-0.3;
						else
						W=0.3;

						initW=10;

						VR=(V+W*L/2.0);
						VL=(V-W*L/2.0);

					}
					if (keys[VK_RIGHT]){
                        
						if (V>=0)
						W=0.3;
						else
						W=-0.3;
						
						initW=10;

						VR=(V+W*L/2.0);
						VL=(V-W*L/2.0);

					}
                    if (keys[VK_SPACE]){
						W=0;
						V=0;
					    VR=0;
					    VL=0;

						if(variables->detener_marcha){
							variables->detener_marcha=false;
							//MessageBox(NULL,"Marcha Activada","CONTROL DE TRACCION",MB_OK|MB_ICONEXCLAMATION);
							Sleep(500);
							printf("Marcha Activada\n");}
						else{
							variables->detener_marcha=true;
							//MessageBox(NULL,"Marcha Detenida","CONTROL DE TRACCION",MB_OK|MB_ICONEXCLAMATION);
							Sleep(500);
							printf("Marcha Detenida\n");}			
					}

                    if (keys['A']){
						PPX=PPX-0.01;
					    printf("pos X= %f , pos Y= %f \n",PPX,PPY);  
					}

					if (keys['S']){
						PPX=PPX+0.01;
					    printf("pos X= %f , pos Y= %f \n",PPX,PPY);  
					}

		            if (keys['D']){
						PPY=PPY-0.01;
					    printf("pos X= %f , pos Y= %f \n",PPX,PPY);  
					}

			        if (keys['F']){
						PPY=PPY+0.01;
					    printf("pos X= %f , pos Y= %f \n",PPX,PPY);  
					}

			        if (keys[VK_F1]){
					ver_panel=true;
					ver_mapa=false;
					ver_cinematica_vel=false;
					ver_cinematica_acel=false;
					tit_pantalla=tit_panel;
                    }

			        if (keys[VK_F2]){
					ver_panel=false;
					ver_mapa=true;
					ver_cinematica_vel=false;
					ver_cinematica_acel=false;
					tit_pantalla=tit_mapa;
					}

			        if (keys[VK_F3]){
					ver_panel=false;
					ver_mapa=false;
					ver_cinematica_vel=true;
					ver_cinematica_acel=false;
					tit_pantalla=tit_cinematica;
					}

			        if (keys[VK_F4]){
					ver_panel=false;
					ver_mapa=false;
					ver_cinematica_vel=false;
					ver_cinematica_acel=true;
					tit_pantalla=tit_cinematica;
					}

					if (keys[VK_F5]){
                    if (habilitar_panel)
                    habilitar_panel=false;   
					else
					habilitar_panel=true;
					}

					if (keys[VK_F6]){
					if(habilitar_letras)
						habilitar_letras=false;
					else
						habilitar_letras=true;
					}

					if (keys[VK_F7]){
					if(configurar_OPEN_GL)
						configurar_OPEN_GL=false;
					else
						configurar_OPEN_GL=true;					
					}

					if (keys[VK_F8]){
                    variables->radio_max=5.0;
					}

					if (keys[VK_F9]){
                    variables->radio_max=10.0;
					}

					if (keys[VK_F10]){
                    variables->radio_max=25.0;
					}

					if (keys[VK_F11]){
                    variables->radio_max=50.0;
					}

					if (keys['1']){
						variables->modo_posicion=0;
						system("cls");
						printf("Posicionamiento ocupando datos de Archivo\n");
					}

					if (keys['2']){
						variables->modo_posicion=1;
						system("cls");
						printf("Posicionamiento ocupando datos de Odometria\n");
					}

					if (keys['3']){
						variables->modo_posicion=2;
						system("cls");
						printf("Posicionamiento ocupando datos de GPS\n");
					}

					if (keys['4']){
						variables->modo_posicion=3;
						system("cls");
						printf("Posicionamiento ocupando %2.2f Odometria ,%2.2f GPS\n",variables->tol,1.0-variables->tol);
					}

					if (keys['5']){
						variables->tol=variables->tol-0.05;
						if (variables->tol<0)
						variables->tol=0.0;
						system("cls");
						printf("Tolerancia %2.2f\n",variables->tol);
					}

					if (keys['6']){
						variables->tol=variables->tol+0.05;
						if (variables->tol>1.0)
						variables->tol=1.0;
						system("cls");
						printf("Tolerancia %2.2f\n",variables->tol);
					}


 				}				
			}
		}
	}

	ShowCursor(true);
	KillGLWindow();									

	return (msg.wParam);
}

LRESULT CALLBACK partida_serial_gps(HWND hDlg,UINT	uMsg,WPARAM	wParam,LPARAM	lParam)	
{
	int wmId,wmEvent,a,b;
	int run_partida=0;
	
	LPSTR IP_AUX;
    
	DrawGLScene(plots->cos_aux,plots->sin_aux);
	SwapBuffers(hDC);

/*	if(run_partida==0){
	    SetDlgItemTextA(hDlg,IDC_IP,IP);
	    run_partida++;}*/

	switch (uMsg)
	{		
	case WM_INITDIALOG:
			//setea la posicion en que aparece el dialogo
			
//			SetDlgItemText(hDlg, IDC_IDEN, mayor);
//			SetWindowPos (hDlg, HWND_TOP,100,50,0,0, SWP_NOSIZE | SWP_NOZORDER);
			//muestra el dialogo
//			ShowWindow (hDlg, SW_SHOW);
		puerto="COM1";

		 SetDlgItemText(hDlg,IDC_COM,puerto);
		 ShowWindow (hDlg, SW_SHOW);
		break;

	case WM_CLOSE:								
		{
			EndDialog(hDlg, LOWORD(wParam));						
			return 0;								
		}
	
	case WM_COMMAND:

		wmId    = LOWORD(wParam); //contiene identificador del menuitem or control que genera el mensaje

		wmEvent = HIWORD(wParam); //especifica que tipo de elemento genera mensaje, por ejemplo 1 si 

/*GetDlgItemTextW(
    HWND hDlg,
    int nIDDlgItem,
    LPWSTR lpString,
    int nMaxCount);*/

		switch(wmId)
		{

		case ID_MANUAL:
			variables->habilitar_gps=true;
            hThreads[5] = CreateThread(NULL,0,modo_gps,"T5",NULL,&iID[5]);
 			EndDialog(hDlg, LOWORD(wParam));
			
        break;
		
		case ID_AUTOMATICO:
			variables->habilitar_gps=true;
            hThreads[5] = CreateThread(NULL,0,modo_gps,"T5",NULL,&iID[5]);
			EndDialog(hDlg, LOWORD(wParam));
			
        break;

		case IDCANCEL:
			variables->habilitar_gps=false;
			EndDialog(hDlg, LOWORD(wParam));					
										
		break;

		case ID_COM1:

            puerto="COM1";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM2:

            puerto="COM2";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM3:

            puerto="COM3";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM4:

            puerto="COM4";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM5:

            puerto="COM5";
            SetDlgItemText(hDlg,IDC_COM,puerto);

        break;

		case ID_COM6:

            puerto="COM6";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM7:

            puerto="COM7";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM8:

            puerto="COM8";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM9:

            puerto="COM9";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM10:

            puerto="COM10";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM11:

            puerto="COM11";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		case ID_COM12:

            puerto="COM12";
            SetDlgItemText(hDlg,IDC_COM,puerto);
		
        break;

		}

		break;
						
	}
	return FALSE;
}

LRESULT CALLBACK partida_serial(HWND hDlg,UINT	uMsg,WPARAM	wParam,LPARAM	lParam)	
{
	int wmId,wmEvent,a,b;
	int run_partida=0;
	
	LPSTR IP_AUX;
    
	DrawGLScene(plots->cos_aux,plots->sin_aux);
	SwapBuffers(hDC);

/*	if(run_partida==0){
	    SetDlgItemTextA(hDlg,IDC_IP,IP);
	    run_partida++;}*/

	switch (uMsg)
	{		
	case WM_INITDIALOG:
			//setea la posicion en que aparece el dialogo
			
//			SetDlgItemText(hDlg, IDC_IDEN, mayor);
//			SetWindowPos (hDlg, HWND_TOP,100,50,0,0, SWP_NOSIZE | SWP_NOZORDER);
			//muestra el dialogo
//			ShowWindow (hDlg, SW_SHOW);
		variables->puerto="COM1";

		 SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		 ShowWindow (hDlg, SW_SHOW);
		break;

	case WM_CLOSE:								
		{
			EndDialog(hDlg, LOWORD(wParam));						
			return 0;								
		}
	
	case WM_COMMAND:

		wmId    = LOWORD(wParam); //contiene identificador del menuitem or control que genera el mensaje

		wmEvent = HIWORD(wParam); //especifica que tipo de elemento genera mensaje, por ejemplo 1 si 

/*GetDlgItemTextW(
    HWND hDlg,
    int nIDDlgItem,
    LPWSTR lpString,
    int nMaxCount);*/

		switch(wmId)
		{

		case ID_MANUAL:
		    
			hThreads[3] = CreateThread(NULL,0,modo_manual_serial,"T4",NULL,&iID[3]);
 			EndDialog(hDlg, LOWORD(wParam));
			
        break;
		
		case ID_AUTOMATICO:

			//variables=new var_robot();		    
			hThreads[4] = CreateThread(NULL,0,modo_autom_serial,"T5",NULL,&iID[4]);
			EndDialog(hDlg, LOWORD(wParam));
			
        break;

		case IDCANCEL:
			
			EndDialog(hDlg, LOWORD(wParam));					
										
		break;

		case ID_COM1:

            variables->puerto="COM1";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM2:

            variables->puerto="COM2";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM3:

            variables->puerto="COM3";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM4:

            variables->puerto="COM4";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM5:

            variables->puerto="COM5";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM6:

            variables->puerto="COM6";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM7:

            variables->puerto="COM7";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM8:

            variables->puerto="COM8";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM9:

            variables->puerto="COM9";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM10:

            variables->puerto="COM10";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM11:

            variables->puerto="COM11";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		case ID_COM12:

            variables->puerto="COM12";
            SetDlgItemText(hDlg,IDC_COM,variables->puerto);
		
        break;

		}

		break;
						
	}
	return FALSE;
}


LRESULT CALLBACK modopartida(HWND hDlg,UINT	uMsg,WPARAM	wParam,LPARAM	lParam)	
{
	int wmId,wmEvent,a,b;
	int run_partida=0;
	LPSTR IP_AUX;
    
	DrawGLScene(plots->cos_aux,plots->sin_aux);
	SwapBuffers(hDC);

/*	if(run_partida==0){
	    SetDlgItemTextA(hDlg,IDC_IP,IP);
	    run_partida++;}*/

	switch (uMsg)
	{		
	case WM_INITDIALOG:
			//setea la posicion en que aparece el dialogo
			
//			SetDlgItemText(hDlg, IDC_IDEN, mayor);
//			SetWindowPos (hDlg, HWND_TOP,100,50,0,0, SWP_NOSIZE | SWP_NOZORDER);
			//muestra el dialogo
//			ShowWindow (hDlg, SW_SHOW);

		 SetDlgItemText(hDlg,IDC_IP,IP);
		 
		break;

	case WM_CLOSE:								
		{
			EndDialog(hDlg, LOWORD(wParam));						
			return 0;								
		}
	
	case WM_COMMAND:

		wmId    = LOWORD(wParam); //contiene identificador del menuitem or control que genera el mensaje

		wmEvent = HIWORD(wParam); //especifica que tipo de elemento genera mensaje, por ejemplo 1 si 

/*GetDlgItemTextW(
    HWND hDlg,
    int nIDDlgItem,
    LPWSTR lpString,
    int nMaxCount);*/

		switch(wmId)
		{

		case IDOK:
		    
										
			//char *IP = "192.168.1.99";
            //int  port= 8101;
            //controler= new robot_control(IP,8181);
			//main(IP,8101);
			//MessageBox(hDlg,IP,"CARGANDO DIRECCION", MB_ICONEXCLAMATION | MB_OK);
	        
			//variables=new var_robot();
			hThreads[0] = CreateThread(NULL,0,modo_manual,"T1",NULL,&iID[0]);
 
//                		hThreads[1] = CreateThread(NULL,0,MyThread,"T2",NULL,&iID[1]);

					
			//estado_control=true;
		    
			//if(estado_control==true)
			//controler->main_robot();
			
			EndDialog(hDlg, LOWORD(wParam));
			
        break;
		
		case IDOK2:

			//variables=new var_robot();		    
			hThreads[1] = CreateThread(NULL,0,MyThread,"T2",NULL,&iID[1]);
			EndDialog(hDlg, LOWORD(wParam));
			
        break;

		case IDCANCEL:
			
			EndDialog(hDlg, LOWORD(wParam));					
										
		break;

		case IDC_IP:

           GetDlgItemText(hDlg,IDC_IP,IP,100);

		}

		break;
						
        break;

	}
	return FALSE;
}


// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg,UINT uMsg,WPARAM	wParam,LPARAM	lParam)
{					DrawGLScene(plots->cos_aux,plots->sin_aux);
					SwapBuffers(hDC);				

	switch (uMsg)
	{   
		case WM_INITDIALOG:
			
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
//						hThreads[0] = CreateThread(NULL,0,MyThread,"T1",NULL,&iID[0]);
//              		hThreads[1] = CreateThread(NULL,0,MyThread,"T2",NULL,&iID[1]);



        		// wait until threads have finished before parent thread exits


				EndDialog(hDlg, LOWORD(wParam));


				return TRUE;
			}
			break;
	}
    return FALSE;
}



LRESULT CALLBACK traslacion(HWND hDlg,UINT	uMsg,WPARAM	wParam,LPARAM	lParam)	
{ 	
	DrawGLScene(plots->cos_aux,plots->sin_aux);
	SwapBuffers(hDC);				

	switch (uMsg)
	{   
		case WM_INITDIALOG:
			
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				
				EndDialog(hDlg, LOWORD(wParam));


				return TRUE;
			}
			break;
	}
    return FALSE; 

}