#ifndef ROBOT_CONTROL_H
#define ROBOT_CONTROL_H

class ArPose;
class ArTime;
class ArRobot;
class ArTcpConnection;
class ArAnalogGyro;
class ConnHandler;
class param_robot;
class robot_control;
class sub_grilla;
class grilla;
class matriz_grilla;


class graficos
{
public:

float *cos_aux;
float *sin_aux;	
int particiones;
double PI;


graficos();

~graficos(){
/*if(cos_aux!=NULL)
delete cos_aux;
if(sin_aux!=NULL)
delete sin_aux;*/
}
//interfaz(void);

private:



};

class sub_grilla
{
public:
int pos_i;
int pos_j;
bool grilla_rec[500][500];
bool grilla_obs[500][500];

sub_grilla(int p_i,int p_j){
    pos_i=p_i;
    pos_j=p_j;
	for(int i=0;i<=500;i++){
       for(int j=0;j<=500;j++){
	      grilla_rec[i][j]=false;
		  grilla_obs[i][j]=false;
	   }
	}

};

~sub_grilla(void){};
private:

};

class grilla
{
public:
sub_grilla *mapa;
int p_m_i;
int p_m_j;
grilla(void){
};

cargar_grilla(int p_i,int p_j){
p_m_i=p_i;
p_m_j=p_j;
mapa=new sub_grilla(p_i,p_j);
};


~grilla(void){
/*if(mapa!=NULL)
delete mapa;*/

};
private:
};

class matriz_grilla
{
public:

bool obs[128][128];
bool rec[128][128];

int i_min;
int i_max;
int j_min;
int j_max;

int i_matriz;
int j_matriz;
int k_matriz;

int i_n;
int j_n;

grilla matriz[100];

void matriz_obs(int i,int j);
void matriz_pos(int i,int j);
matriz_grilla(void);
~matriz_grilla(void){};
private:
};



class var_robot
{
public:

float pos_X_ini;
float pos_Y_ini;
float pos_X;
float pos_Y;
float angulo_rot;
float volt_bat;
float velocidad;
float vel_angulo_rot;
float aceleracion;
float acel_angulo_rot;
float tiempo;

float vec_pos_X[9999];
float vec_pos_Y[9999];
float vec_pos_X_UTM[9999];
float vec_pos_Y_UTM[9999];
float X_max;
float Y_max;
float vec_ang;
int vec_j;


float vec_velocidad[599];
float vec_vel_angulo_rot[599];
float vec_aceleracion[599];
float vec_acel_angulo_rot[599];
int vec_k;

float tiempo_ant;
bool inicio;
bool detener_marcha;

char *puerto;

char *data_ruta;

int modo_posicion;
bool habilitar_gps;
float tol;

int k_UTM;
float *X_UTM; //valor en mm
float *Y_UTM; //valor en mm

bool ruta_state;

char latitud;
int ang_lat;
float min_lat;

char longitud;
int ang_long;
float min_long;

int j_actual; 
int k_actual;

float desp_X;
float desp_Y;

char *data_sick;

bool laser_state;
bool habilitar_laser;
float *r_laser;
float radio_max;
int n_laser;

bool grilla_rec[500][500];
bool grilla_obs[500][500];
matriz_grilla *matrix;
int modo_comunicacion;
bool guardar;




var_robot();
~var_robot(void){

/*if (puerto!=NULL)
delete puerto;
if (data_ruta!=NULL)
delete data_ruta;
if (data_sick!=NULL)
delete data_sick;
if (r_laser!=NULL)
delete r_laser;
if (matrix!=NULL)
delete matrix;*/

};


void enter_laser(void);
void cargar_ruta(void);
void actualizar_grilla(void);
void enter_data(ArPose *posicion,ArRobot *robot_aux);
void enter_data(ArPose *posicion,float tiempo);
void actualizar_datos(void);
//void guardar_datos(char *archivo,FILE *datos_trayectoria);
//void detener_guardar_datos(FILE *datos_trayectoria);

private:
};

int main_(char *IP,int port,var_robot *variables);
int main_manual(char *IP,int port,float *VR,float *VL,bool *continuar,var_robot *variables);
int main_serial(char *PUERTO,var_robot *variables);
int main_manual_serial(char *PUERTO,float *VR,float *VL,bool *continuar,var_robot *variables);
//int main(int argc, char **argv);
int server(void);
int client(void);


#endif